
#include <iostream>
#include <string>
#include <fstream>

using namespace std;

#include "Connect4.h"
#include "Player.h"
#include "LMSLearner.h"


int main()
{
	Connect4StateEvaluator evaluator_Black;
	Connect4GameStateFeature evaluatorWeights_Black;
	evaluatorWeights_Black.feature[Connect4GameStateFeature::BLACK_DOUBLE]	= 0.072;
	evaluatorWeights_Black.feature[Connect4GameStateFeature::RED_DOUBLE]		= -0.09;
	evaluatorWeights_Black.feature[Connect4GameStateFeature::BLACK_TRIPLE]	= 0.091;
	evaluatorWeights_Black.feature[Connect4GameStateFeature::RED_TRIPLE]		= -0.273;
	evaluatorWeights_Black.feature[Connect4GameStateFeature::BLACK_QUAD]		= 0.164;
	evaluatorWeights_Black.feature[Connect4GameStateFeature::RED_QUAD]		= -1.0;
	evaluatorWeights_Black.feature[Connect4GameStateFeature::BLACK_CENTER]	= 0.091;
	evaluatorWeights_Black.feature[Connect4GameStateFeature::RED_CENTER]		= -0.091;
	evaluator_Black.setWeights(evaluatorWeights_Black);

	Connect4StateEvaluator evaluator_Red;
	Connect4GameStateFeature evaluatorWeights_Red;

	/*srand(time(NULL));
	evaluatorWeights_Red.feature[Connect4GameStateFeature::BLACK_DOUBLE]	= -0.09 + (double)((rand()%1001) - 500)/2000.0;
	evaluatorWeights_Red.feature[Connect4GameStateFeature::RED_DOUBLE]	= 0.072 + (double)((rand()%1001) - 500)/2000.0;
	evaluatorWeights_Red.feature[Connect4GameStateFeature::BLACK_TRIPLE]	= -0.273 + (double)((rand()%1001) - 500)/2000.0;
	evaluatorWeights_Red.feature[Connect4GameStateFeature::RED_TRIPLE]	= 0.091+ (double)((rand()%1001) - 500)/2000.0;
	evaluatorWeights_Red.feature[Connect4GameStateFeature::BLACK_QUAD]	= -1.0 + (double)((rand()%1001) - 500)/2000.0;
	evaluatorWeights_Red.feature[Connect4GameStateFeature::RED_QUAD]		= 0.164 + (double)((rand()%1001) - 500)/2000.0;
	evaluatorWeights_Red.feature[Connect4GameStateFeature::BLACK_CENTER]	= -0.091 + (double)((rand()%1001) - 500)/2000.0;
	evaluatorWeights_Red.feature[Connect4GameStateFeature::RED_CENTER]	= 0.091 + (double)((rand()%1001) - 500)/2000.0*/;

	evaluatorWeights_Red.feature[Connect4GameStateFeature::BLACK_DOUBLE]	= -0.414265;
	evaluatorWeights_Red.feature[Connect4GameStateFeature::RED_DOUBLE]	= 0.121151;
	evaluatorWeights_Red.feature[Connect4GameStateFeature::BLACK_TRIPLE]	= -0.132171;
	evaluatorWeights_Red.feature[Connect4GameStateFeature::RED_TRIPLE]	= -0.0326753;
	evaluatorWeights_Red.feature[Connect4GameStateFeature::BLACK_QUAD]	= -1;
	evaluatorWeights_Red.feature[Connect4GameStateFeature::RED_QUAD]		= 0.239334;
	evaluatorWeights_Red.feature[Connect4GameStateFeature::BLACK_CENTER]	=-0.259813;
	evaluatorWeights_Red.feature[Connect4GameStateFeature::RED_CENTER]	= -0.0984945;

	evaluator_Red.setWeights(evaluatorWeights_Red);


	//Connect4StateEvaluator evaluator_Black;
	//Connect4GameStateFeature evaluatorWeights_Black;
	//evaluatorWeights_Black.feature[Connect4GameStateFeature::BLACK_DOUBLE]	= 0.121151;
	//evaluatorWeights_Black.feature[Connect4GameStateFeature::RED_DOUBLE]		= -0.414265;
	//evaluatorWeights_Black.feature[Connect4GameStateFeature::BLACK_TRIPLE]	= -0.0326753;
	//evaluatorWeights_Black.feature[Connect4GameStateFeature::RED_TRIPLE]		= -0.132171;
	//evaluatorWeights_Black.feature[Connect4GameStateFeature::BLACK_QUAD]		= 0.239334;
	//evaluatorWeights_Black.feature[Connect4GameStateFeature::RED_QUAD]		= -1.0;
	//evaluatorWeights_Black.feature[Connect4GameStateFeature::BLACK_CENTER]	= -0.0984945;
	//evaluatorWeights_Black.feature[Connect4GameStateFeature::RED_CENTER]		= -0.259813;
	//evaluator_Black.setWeights(evaluatorWeights_Black);

	//Connect4StateEvaluator evaluator_Red;
	//Connect4GameStateFeature evaluatorWeights_Red;

	//evaluatorWeights_Red.feature[Connect4GameStateFeature::BLACK_DOUBLE]	= -0.09;
	//evaluatorWeights_Red.feature[Connect4GameStateFeature::RED_DOUBLE]	= 0.072;
	//evaluatorWeights_Red.feature[Connect4GameStateFeature::BLACK_TRIPLE]	= -0.273;
	//evaluatorWeights_Red.feature[Connect4GameStateFeature::RED_TRIPLE]	= 0.091;
	//evaluatorWeights_Red.feature[Connect4GameStateFeature::BLACK_QUAD]	= -1;
	//evaluatorWeights_Red.feature[Connect4GameStateFeature::RED_QUAD]		= 0.164;
	//evaluatorWeights_Red.feature[Connect4GameStateFeature::BLACK_CENTER]	= -0.091;
	//evaluatorWeights_Red.feature[Connect4GameStateFeature::RED_CENTER]	= 0.091;

	//evaluator_Red.setWeights(evaluatorWeights_Red);





	std::vector<game::Player<Connect4GameState, Connect4StateEvaluator>*> players(2);
	int BLACK_PLAYER = 0;
	int RED_PLAYER = 1;
	int depth = 4;

	players[BLACK_PLAYER] = new game::AIPlayer<Connect4GameState, Connect4StateEvaluator>();
	players[BLACK_PLAYER]->setEvaluator(evaluator_Black);
	players[BLACK_PLAYER]->setDepth(depth);

	players[RED_PLAYER] = new game::AIPlayer<Connect4GameState, Connect4StateEvaluator>();
	players[RED_PLAYER]->setEvaluator(evaluator_Red);
	players[RED_PLAYER]->setDepth(depth);

/*	
	std::string playerName;
	std::cout << "\nConnect4 Game\n\n" << std::endl;
	std::cout << "Select Black Player<1> (type 'AI' for AI player): ";
	getline(cin,playerName);


	if(playerName == "AI")
	{
		players[BLACK_PLAYER] = new game::AIPlayer<Connect4GameState, Connect4StateEvaluator>();
		players[BLACK_PLAYER]->setEvaluator(evaluator_Black);
		std::cout << "\tEnter search depth(1-8): ";
		int depth;
		std::cin >> depth;
		while(depth < 1 || depth > 8)
		{
			std::cout << "\tEnter search depth(1-8): ";
			std::cin >> depth;
		}
		players[BLACK_PLAYER]->setDepth(depth);
	}
	else
	{
		players[BLACK_PLAYER] = new game::HumanPlayer<Connect4GameState, Connect4StateEvaluator>();
	}
	getline(cin,playerName);
	std::cout << "Select Red Player<2> (type 'AI' for AI player): ";
	getline(cin,playerName);

	if(playerName == "AI")
	{
		players[RED_PLAYER] = new game::AIPlayer<Connect4GameState, Connect4StateEvaluator>();
		players[RED_PLAYER]->setEvaluator(evaluator_Red);
		std::cout << "\tEnter search depth(1-8): ";
		int depth;
		std::cin >> depth;
		while(depth < 1 || depth > 8)
		{
			std::cout << "\tEnter search depth(1-8): ";
			std::cin >> depth;
		}
		players[RED_PLAYER]->setDepth(depth);
	}
	else
	{
		players[RED_PLAYER] = new game::HumanPlayer<Connect4GameState, Connect4StateEvaluator>();
	}
*/
	/*LMSConnect4Learner lmsTrainer;
	lmsTrainer.learnRate = 0.001;
	lmsTrainer.setPlayers(players);

	Connect4GameStateFeature updatedWeights_Black;
	lmsTrainer.train(updatedWeights_Black, 50);

	std::ofstream weightsFile;
	weightsFile.open("TrainedWeights.txt");
	for(int i = 0; i < updatedWeights_Black.feature.size(); ++i)
	{
		weightsFile << updatedWeights_Black.feature[i] << '\t';
	}
	weightsFile << std::endl;
	weightsFile.close();


	evaluator_Black.setWeights(updatedWeights_Black);
	players[BLACK_PLAYER]->setEvaluator(evaluator_Black);*/

	Connect4Game c4game(players);
	int winner = c4game.play();

	system("PAUSE");
	return 0;
}
